#version 330 core

layout(location = 0)in vec3 position;
layout(location = 1)in vec3 normal;
layout(location = 2)in vec2 uv;

out vec3 worldNormal;
out vec2 texCoords;
out vec3 worldPosition;
out vec3 cameraPosition;

uniform vec3 color;
uniform mat4 model;
uniform mat4 view_proj;
uniform mat3 normalMatrix;
uniform vec3 camera;

void main(){
	gl_Position = view_proj * model * vec4(position, 1);

	texCoords   = uv;
	worldNormal = normalMatrix * normal;
	worldPosition =  (model * vec4(position, 1)).xyz;
	cameraPosition = camera;

	mat3 nn = normalMatrix;
}