#version 330 core

layout(location = 0) out vec4 outColor;

in float fLifetime;
in vec2 uvs;
in vec3 tmp;

uniform sampler2D tex;
uniform vec3 cameraPos;
uniform int boost;

void main(){
	//outColor = vec4(tmp ,0.5);

	vec4 t =   texture( tex, uvs);
	t.w = (t.x + t.y + t.z) / 3.0;
	t.x = 0.99;
	t.y = 0.99;
	t.z = 0.0;

	if(boost == 1){
		t.x = 0;
		t.z = 1;
	}

	if(fLifetime < 3){
		//t.x *= fLifetime / 3;
		t.y *= fLifetime / 3;
		
	}

	if(fLifetime < 1){
		t.w *= fLifetime;
	}

	outColor = t;
}


