#version 330 core 

layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

in float vLifetime[];
in vec3  vDirection[];  
in vec3  vCameraPos[];

out float fLifetime;
out vec2 uvs;
out vec3 tmp;

uniform float size;
uniform mat4 model;
uniform mat4 view_proj;

void emit(vec4 pos, float scale, float max)
{
	vec3 cameraDir = normalize(vCameraPos[0] - vec3(pos.x, pos.y, pos.z));
	vec4 target =  view_proj * model * vec4(0,50,0,1);
	vec3 moveDir = normalize(vec3(target.x, target.y, target.z) - vec3(pos.x, pos.y, pos.z));
	vec3 xNormal = cross(cameraDir, moveDir);
	xNormal = normalize(xNormal);

	tmp = cameraDir;

	vec4 moveDir4 = vec4(moveDir, 1)* vec4(9,9,9,1);
	vec4 xNormal4 = vec4(xNormal, 1) ;//* vec4(0.3,0.3,0.3,1);


	mat4 MVP= view_proj;
	float w = (max*scale) / 2.0;

	tmp = cameraDir;
	
	gl_Position = pos + vec4(-w, -w, 0, 1);
	gl_PointSize = 1.0;
	fLifetime = vLifetime[0];
	uvs = vec2(0, 0);
	EmitVertex();

	tmp = cameraDir;
	gl_Position =   pos + vec4(-w, w, 0, 1);
	gl_PointSize = 1.0;
	fLifetime = vLifetime[0];
	uvs = vec2(1, 0);
	EmitVertex();

	tmp = cameraDir;
	gl_Position =  pos + vec4(w, -w, 0, 1);
	gl_PointSize = 1.0;
	fLifetime = vLifetime[0];
	uvs = vec2(0, 1);
	EmitVertex();

	tmp = cameraDir;
	gl_Position =  pos + vec4(w, w, 0, 1);
	gl_PointSize = 1.0;
	fLifetime = vLifetime[0];
	uvs = vec2(1, 1);
	EmitVertex();		


	EndPrimitive();
}

void main() {  

	vec4 pos = gl_in[0].gl_Position;

	emit(pos, 0.1 * size , 3);
}  

