#version 330 core

layout(location = 0) in vec3  position;
layout(location = 1) in vec3  direction;
layout(location = 2) in float lifetime;

uniform mat4 model;
uniform mat4 view_proj;
uniform vec3 cameraPos;

out vec3  vDirection;
out float vLifetime;
out vec3  vCameraPos;


void main()
{

	gl_Position  = view_proj * model * vec4(position, 1);
	vec4 camPos  = view_proj * vec4(cameraPos, 1);
	vCameraPos = vec3(camPos.x, camPos.y, camPos.z);
	vDirection = direction;
	vLifetime  = lifetime;
	
}