#version 330 core 

layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

in float vLifetime[];
in vec3  vDirection[];  

out float fLifetime;
out vec2 uvs;

void emit(vec4 pos, float scale, float max)
{
	float w = (max*scale) / 2.0;

	gl_Position = pos + vec4(-w, -w, 0, 1);
	gl_PointSize = 10.0;
	fLifetime = vLifetime[0];
	uvs = vec2(0, 0);
	EmitVertex();

	gl_Position =  pos + vec4(-w, w, 0, 1);
	gl_PointSize = 1.0;
	fLifetime = vLifetime[0];
	uvs = vec2(0, 1);
	EmitVertex();

	gl_Position =  pos + vec4(w, -w, 0, 1);
	gl_PointSize = 1.0;
	fLifetime = vLifetime[0];
	uvs = vec2(1, 0);
	EmitVertex();

	gl_Position =  pos+ vec4(w, w, 0, 1);
	gl_PointSize = 1.0;
	fLifetime = vLifetime[0];
	uvs = vec2(1, 1);
	EmitVertex();	

	EndPrimitive();
}

void main() {  

	vec4 pos = gl_in[0].gl_Position;

	emit(pos, 0.1, 1);
}  

