#version 330 core

layout(location = 0) out vec4 outColor;

in vec3 worldNormal;
in vec3 worldPosition;
in vec2 texCoords;
in vec3 cameraPosition;

uniform sampler2D color_texture;

void main(){

	vec3 camera = vec3(0, 0, 0);
	camera = cameraPosition;
	vec3 diffuse = vec3(1, 1, 1);
	vec3 ambient = vec3(0.1, 0.1, 0.1);

	// reflection
	vec3 specular = vec3(1, 1, 1);
	float shininess = 40;

	vec3 diffuseColor = diffuse * texture(color_texture, texCoords).xyz;
	vec3 ambientColor = ambient * texture(color_texture, texCoords).xyz;

	vec3 N = normalize(worldNormal);
	vec3 V = normalize(camera - worldPosition);

	
	vec3 L = vec3(-1, -1, 1); // direction
	vec3 I = vec3(0.7, 0.7, 0.7); // intensity

	float LN = dot(L, N);
	if(LN < 0)
		LN = 0;



	vec3 diff = ((I * LN) * diffuseColor);

	vec3 spec = specular * LN;

	vec3 H = normalize(V + L);
	float NH = dot(H, N);

	if(NH < 0)
		NH = 0;

	vec3 Ispec =  (I * pow(NH, shininess)) * spec;



	
	vec3 outC =    texture(color_texture, texCoords).xyz;

	float black = outC.x + outC.y + outC.z;

	outColor = vec4(outC, black < 0.3 ? black : 1);

}
