#version 330 core

layout(location = 0)in vec3 position;
layout(location = 1)in vec3 normal;
layout(location = 2)in vec2 uv;

out vec3 worldNormal;
out vec2 texCoords;
out vec3 worldPosition;
out vec3 cameraPosition;
out vec4 shadowMapCoords;

uniform mat4 model;
uniform mat4 view_proj;
uniform mat3 normalMatrix;
uniform vec3 camera;
uniform mat4 M_Vl_Pl_L;
uniform int  renderShadow;

uniform mat4 prevMVP;
uniform int  motionBlurEnabled;

out vec4 vPrevPosition;
out vec4 vCurrPosition;

void main(){
	gl_Position = view_proj * model * vec4(position, 1);

	texCoords   = uv;
	worldNormal = normalMatrix * normal;
	worldPosition =  (model * vec4(position, 1)).xyz;
	cameraPosition = camera;


	if(renderShadow == 1)
		shadowMapCoords = M_Vl_Pl_L * vec4(position, 1);
	

	if(motionBlurEnabled == 1)
	{
		vPrevPosition = prevMVP * vec4(position, 1);
		vCurrPosition = view_proj * model * vec4(position, 1);
	}
		
}